/******************************
	Maxthon Facebook Sidebar
	By Neo101
	Version 3.0.0
******************************/

var SECURITY_ID = max_security_id
var PLUGIN_NAME = 'Maxthon Facebook Sidebar'
var APP_URL = 'http://apps.facebook.com/maxthon/'
var INSTALL_URL = 'http://www.facebook.com/r.php?api_key=6d3518041a161d4272902c82fe97408a'
var REST_SERVER_URL = 'http://facebookapp.maxthon.com/rest.php'

var popup = new Popup()



window.onload = function(){
	Facebook.init()
	
	if(!settings.sessionKey || !settings.uid){
		Facebook.showAuthentication()
	} else {
		Facebook.getUpdates()
		window.setInterval(Facebook.getUpdates, settings.autoRefreshTime * 60 * 1000)
	}
	
	Facebook.resizeMainContent()
	$id('profileLink').href = 'http://www.facebook.com/profile.php?id=' + settings.uid
}


window.onresize = function(){
	Facebook.resizeMainContent()
}



var notificationCount = {
	messages: 0,
	pokes: 0,
	friendRequests: 0,
	friendUpdates: 0
}



var Facebook = {
	getSessionInterval: null
}


Facebook.init = function(){
	settings = MaxLib.loadSettingsFile()
}


/****************** Get Updates **********************/

Facebook.getUpdates = function(){
	if(!settings.uid || !settings.sessionKey){
		return
	}
	
	try{
		var object = new XmlHttpObj()
		var callBack = {'onFailure': Facebook.getUpdatesFailure,
						'onSuccess': Facebook.getUpdatesResult,
						'headers': {'content-type': 'application/x-www-form-urlencoded'}}
		var postData = 'uid=' + settings.uid + '&session=' + settings.sessionKey + '&action=info&version=1.0'
		object.connect(REST_SERVER_URL, 'POST', callBack, postData)
	} catch(e){
		Facebook.showError('Failed to open connection. Error: ' + e.description)
	}
}


Facebook.getUpdatesFailure = function(xmlHttpObject, callBack){
	Facebook.showError('Failed to connection to server. Status: ' + xmlHttpObject.status + '-' + xmlHttpObject.statusText)
	Facebook.processUpdate()
}


Facebook.getUpdatesResult = function(xmlHttpObject, callBack){
	var responseJSON = xmlHttpObject.responseText
	//alert(responseJSON)
	try{
		eval('var response = ' + responseJSON)
	} catch(e) {
		var response = null
	}
	
	if(response == null){
		Facebook.showError('Error! Response: ' + responseJSON.replace(/<|>/g, ''))
		Facebook.processUpdate()
	} else {
		if(response.error_msg){
			Facebook.showError('Error! ' + response.error_code + ' - ' + response.error_msg)
			if(response.error_code && response.error_code == '102'){
				Facebook.logout()
				return
			}
		}
		Facebook.processUpdate(response)
	}
}


Facebook.processUpdate = function(response){
	if(!response) response = {}
	try{
		Facebook.processGetFriendUpdates(response['friends'])
	} catch(e){
		Facebook.showError('Error: ' + e.description)
	}
	try{
		Facebook.processGetEvents(response['events'])
	} catch(e){
		Facebook.showError('Error: ' + e.description)
	}
	try{
		Facebook.processGetFriendRequests(response['friendRequests'])
	} catch(e){
		Facebook.showError('Error: ' + e.description)
	}
	try{
		Facebook.processGetNotifications(response['notifications'])
	} catch(e){
		Facebook.showError('Error: ' + e.description)
	}
}


/****************** Authentication **********************/


Facebook.logout = function(){
	settings.sessionKey = ''
	settings.uid = ''
	MaxLib.saveSettings(settings)
	Facebook.showAuthentication()
}


Facebook.showAuthentication = function(){
	$hide('main')
	$show('authentication')
	$hide('logoutLink')
	$hide('shareButton')
}


Facebook.openLoginPage = function(){
	Facebook.openUrl(INSTALL_URL, true)
	window.setTimeout(Facebook.authClick, 100)
}


Facebook.checkTab = function(tabIndex, url){
	try{
		var tabUrl = external.get_tab(SECURITY_ID, tabIndex).document.URL
		//alert(tabUrl + '\n' + url)
		if(tabUrl.indexOf(url) == 0){
			return true
		}
	} catch(e){}
	return false
}


Facebook.authClick = function(){
	$show('step2')
	$id('toStep2').innerHTML = 'Link has been opened.'
	
	Facebook.getSessionInterval = window.setInterval(Facebook.getSession, 2000)
	
	window.setTimeout(Facebook.focusAuthTab, 2000)
}


Facebook.focusAuthTab = function(){
	var url = 'http://apps.facebook.com/'
	
	if(Facebook.checkTab(external.cur_sel, url)){
		return // auto-focus probably enabled
	}
	else if(Facebook.checkTab(external.cur_sel + 1, url)){
		external.activate_tab(SECURITY_ID, external.cur_sel + 1)// auto-focus probably disabled
	} else if(Facebook.checkTab(external.tab_count - 1, url)){
		external.activate_tab(SECURITY_ID, external.tab_count - 1) // tab doesn't open next to current
	}
}
 

Facebook.getSession = function(manual){
	var url = APP_URL
	if(!Facebook.checkTab(external.cur_sel, url)){
		if(manual){
			Facebook.showError('Failed to get session. Make sure that the page you have currently open is <a href="' + APP_URL + '" target="_blank">' + APP_URL + '</a>')
		}
		return
	}
	var nodes = external.get_tab(SECURITY_ID, external.cur_sel).document.getElementsByTagName('i')
	for(var i=0; i<nodes.length; i++){
		if(nodes[i].className == 'srt'){
			var value = nodes[i].innerText.replace(/^\s+|\s+$/g, '')
			var split = value.split('-%-')
			if(split.length != 2){
				Facebook.showError('Failed to get session.')
				return
			}
			settings.sessionKey = split[1]
			settings.uid = split[0]
			MaxLib.saveSettings(settings)
			location.reload()
			return
		}
	}
	//Facebook.showError('Failed to get session!')
}




/****************** Friends **********************/



Facebook.processGetFriendUpdates = function(friendsArray){
	if(friendsArray == null){
		$id('friendsList').innerHTML = 'Error'
		return
	}
	
	var html = ''
	
	if(friendsArray.length > 0){
		html += '<table>'
		for(var i=0; i<friendsArray.length && i<settings.maxNumberOfFriends; i++){
			var friend = friendsArray[i]
			
			html += '<tr>'
			html += '<td style="width:50px">'
			if(friend.pic_square != ''){
				html += '<a href="http://www.facebook.com/profile.php?id=' + friend.uid + '" target="_blank">'
				html += '<img src="' + friend.pic_square + '" />'
				html += '</a>'
			} else {
				html += '<div class="middle">?</div>'
			}
			html += '</td>'
			html += '<td>'
			html += '<a href="http://www.facebook.com/profile.php?id=' + friend.uid + '" target="_blank">'
			html += friend.name
			html += '</a> '
			html += Facebook.stripText(friend.status.message)
			html += '<div class="time-small">' + Facebook.timeAgo(friend.status.time) + '</div>'
			html += '</td>'
			html += '</tr>'
		}
		html += '</table>'
	} else {
		html += 'No friend updates found'
	}

	$id('friendsList').innerHTML = html
}



Facebook.processGetFriendRequests = function(friendsArray){
	if(friendsArray == null){
		$id('friendRequests').innerHTML = 'Error'
		return
	}
	
	var html = ''
	if(friendsArray.length > 0){
		html += '<ul class="small">'
		for(var i=0; i<friendsArray.length && i<settings.maxNumberOfInvites; i++){
			var friend = friendsArray[i]
			html += '<li>'
			html += '<a href="http://www.facebook.com/profile.php?id=' + friend.uid + '" target="_blank">'
			html += friend.name
			html += '</a>'
			html += '</li>'
		}
		html += '</ul>'
	} else {
		html += 'No friend requests'
	}
	$id('friendRequests').innerHTML = html
}




/****************** Notifications **********************/



Facebook.processGetNotifications = function(responseObj){
	if(!responseObj || !responseObj.messages){
		$id('notifications').innerHTML = 'Error'
		return
	}
	
	var html = ''
	html += '<h4><a href="http://www.facebook.com/inbox/" target="_blank">Messages</a></h4>'
	
	html += '<label>Unread:</label>'
	if(responseObj.messages.unread > 0){
		html += '<a href="http://www.facebook.com/inbox/" target="_blank"><b>'
		if(responseObj.messages.unread == 1){
			html += '1 new Message'
		} else {
			html += responseObj.messages.unread + ' new Messages'
		}
		html += '</b></a><br>'
	} else {
		html += 'No new Messages<br>'
	}
	if(responseObj.messages.most_recent > 0){
		html += '<label>Most Recent:</label>' + Facebook.timeAgo(responseObj.messages.most_recent)
	}
	
	if(responseObj.pokes.unread > 0){
		html += '<h4><a href="http://www.facebook.com/pokes.php" target="_blank">Pokes</a></h4>'
		html += '<label>New:</label>'
		html += '<a href="http://www.facebook.com/pokes.php" target="_blank"><b>'
		if(responseObj.pokes.unread == 1){
			html += '1 new Poke'
		} else {
			html += responseObj.pokes.unread + ' new Pokes'
		}
		html += '</b></a><br>'
		if(responseObj.pokes.most_recent > 0){
			html += '<label>Most Recent:</label>' + Facebook.timeAgo(responseObj.pokes.most_recent)
		}
	}
	$id('notifications').innerHTML = html

	if(settings.showPopup){
		Facebook.checkNewUpdates(responseObj)
	}
}


Facebook.checkNewUpdates = function(obj){
	var message = ''
	if(notificationCount.messages < obj.messages.unread){
		var difference = obj.messages.unread - notificationCount.messages
		message += '<li><a href="http://www.facebook.com/inbox/" onfocus="this.blur()" ' + 
							'onclick="parent.Facebook.openUrl(this.href); return false">'
		if(difference == 1){
			message += 'One new Message</a></li>'
		} else {
			message += difference + ' new Messages</a></li>'
		}
		
	}
	if(notificationCount.pokes < obj.pokes.unread){
		var difference = obj.pokes.unread - notificationCount.pokes
		message += '<li><a href="http://www.facebook.com/pokes.php" onfocus="this.blur()" ' + 
							'onclick="parent.Facebook.openUrl(this.href); return false">'
		if(difference == 1){
			message += 'One new Poke</a></li>'
		} else {
			message += difference + ' new Pokes</a></li>'
		}
	}
	if(notificationCount.friendRequests < obj.friend_requests.length){
		var difference = obj.friend_requests.length - notificationCount.friendRequests
		message += '<li><a href="http://www.facebook.com/reqs.php" onfocus="this.blur()" ' + 
							'onclick="parent.Facebook.openUrl(this.href); return false">'
		if(difference == 1){
			message += 'One new friend request</a>'
		} else {
			message += difference + ' new friend requests</a>'
		}
		message += '</li>'
	}
	notificationCount.messages = obj.messages.unread
	notificationCount.pokes = obj.pokes.unread
	notificationCount.friendRequests = obj.friend_requests.length
	
	if(message != ''){
		popup.show('<ul>' + message + '</ul>')
	}
	
	window.setTimeout(function(){popup.object.hide()}, 10000)
}






/****************** Events **********************/


Facebook.processGetEvents = function(eventArray){
	if(eventArray == null){
		$id('eventsList').innerHTML = 'Error'
		return
	}
	
	var html = ''
	if(eventArray.length > 0){
		for(var i=0; i<eventArray.length && i<settings.maxNumberOfEvents; i++){
			var event = eventArray[i]
			var tooltip = 'Event Type: ' + event.event_subtype + '\n'
			tooltip += 'Location: ' + event.location + '\n'
			tooltip += 'Description: ' + event.description
			html += '<h4 title="' + tooltip + '">'
			html += '<a href="http://www.facebook.com/event.php?eid=' + event.eid + '" target="_blank">'
			html += event.name
			html += '</a>'
			html += '</h4>'
			html += '<label>Date:</label>' + Facebook.eventDate(event.start_time, event.end_time)
		}
	} else {
		html += 'No events found for this week'
	}

	$id('eventsList').innerHTML = html
}




/****************** Time functions **********************/


Facebook.convertTime = function(timeString){
	try{
		var d = new Date()
		d.setTime(timeString * 1000)
		return (d.getMonth() + 1) + '-' + d.getDate() + '-' + d.getFullYear() + ' ' + 
					Facebook.getTime(d)
	} catch(e){
		return 'TimeError'
	}
}


Facebook.eventDate = function(startTime, endTime){
	var timezoneOffset = settings.eventTimezoneOffset || -8
	startTime = parseInt(startTime) + timezoneOffset * 3600
	endTime = parseInt(endTime) + timezoneOffset * 3600
	var startDate = new Date(startTime * 1000)
	var endDate = new Date(endTime * 1000)
	
	if(startDate.getDate() == endDate.getDate()){
		return (startDate.getMonth() + 1) + '-' + startDate.getDate() + '-' + startDate.getFullYear() 
					+ ' ' + Facebook.getTime(startDate) + ' - ' + 
						Facebook.getTime(endDate)
	}
	return (startDate.getMonth() + 1) + '-' + startDate.getDate() + '-' + startDate.getFullYear() 
					+ ' ' + Facebook.getTime(startDate) +
				'<br /><label>End Date:</label>' + 
				(endDate.getMonth() + 1) + '-' + endDate.getDate() + '-' + endDate.getFullYear() 
					+ ' ' + Facebook.getTime(endDate)
}


Facebook.getTime = function(dateObj){
	var hours = dateObj.getHours()
	var minutes = dateObj.getMinutes()
	if(hours.toString().length == 1){
		hours = '0' + hours
	}
	if(minutes.toString().length == 1){
		minutes = '0' + minutes
	}
	return hours + ':' + minutes
}


Facebook.timeAgo = function(mostRecentTime){
	var currentTime = new Date().getTime() / 1000
	var difference = currentTime - mostRecentTime
	var time
	if(difference < 3600){
		time = Math.round( difference / 60 ) + ' minutes ago'
	} else if(difference < 3600 * 24){
		time = Math.round( difference / 3600 ) + ' hours ago'
	} else {
		time = Math.round( difference / 3600 / 24 ) + ' days ago'
	}
	return time
}


/****************** Other functions **********************/




Facebook.shareCurrentPage = function(){
	try{
		var tabDocument = external.get_tab(SECURITY_ID, external.cur_sel).document
	} catch(e){
		Facebook.showError('Failed to get current location.', 5)
		return
	}
	var url = 'http://www.facebook.com/share.php?u=' + encodeURIComponent(tabDocument.URL) + '&t=' + encodeURIComponent(tabDocument.title)
	//window.showModelessDialog(url, null, 'toolbar:0,status:0,scroll:No, resizable:1,dialogWidth:630px,dialogHeight:450px')
	Facebook.openUrl(url, true)
	
}


Facebook.openUrl = function(url, windowOpenFirst){
	if(windowOpenFirst){
		try{
			window.open(url)
		} catch(e){
			external.max_newTab(SECURITY_ID, url)
		}
	} else{
		try{
			external.max_newTab(SECURITY_ID, url)
		} catch(e){
			window.open(url)
		}
	}
	window.setTimeout(function(){Facebook.focusTab(url)}, 1000)
}

Facebook.focusTab = function(url){
	for(var i=0; i<external.tab_count; i++){
		if(Facebook.checkTab(i, url)){
			external.activate_tab(SECURITY_ID, i)
			return
		}
	}
}


Facebook.showError = function(message, displayTime){
	messageLib.setMessage(message, displayTime || 300)
}

	
Facebook.resizeMainContent = function(){
	var height = document.body.clientHeight - 120
	if(height > 0){
		$id('main').style.height = height
		$id('authentication').style.height = height
	}
}


Facebook.stripText = function(text){
    return text.replace(/</g, '&lt;').replace(/>/g, '&gt;')
}



var messageLib = {

	timeout: null,
	
	setMessage: function(text, displayTime){
		$show('message')
		$hide('shareButton')
		$setInnerHtml('message', text)
		try{
			window.clearTimeout(messageLib.timeout)
		} catch(e){}
		messageLib.timeout = window.setTimeout(messageLib.clearMessage, (displayTime || 5) * 1000)
	},

	clearMessage: function(){
		try{
			window.clearTimeout(messageLib.timeout)
		} catch(e){}
		$hide('message')
		$show('shareButton')
	}
}




function Popup(){
	this.object = window.createPopup()
	this.object.document.createStyleSheet('stylesheets/PopupStyleSheet.css');
	this.object.document.body.innerHTML = '<h1>' +
							'<img src="images/facebook.gif" /> Facebook Update' +
						  '</h1>' +
						  'What\'s new:' +
						  '<div id="message"></div>'
}

Popup.prototype.show = function(html){
	this.object.document.getElementById('message').innerHTML = html
	this.object.show(screen.availWidth-200, screen.availHeight-100, 200, 100)
}
