/**************************
	Maxthon Library
	By Neo101
	Version 2.0.0
**************************/


var MaxLib = {
	M1_DATA_FOLDER : 'data/',
	M2_DATA_FOLDER : null,
	SETTINGS_FILE: 'settings.js',
	DEFAULT_SETTINGS_FILE: 'defaultSettings.js'
}
	
/**********************   read/write files   *****************************/
	
MaxLib.readFile = function(filename, folder) {
	return external.readFile(SECURITY_ID, PLUGIN_NAME, 
						(folder ? folder + '/' : (this.M2_DATA_FOLDER || this.M1_DATA_FOLDER)) + filename)
}


MaxLib.writeFile = function(filename, data, folder) {
	external.writeFile(SECURITY_ID, PLUGIN_NAME, 
						(folder ? folder : (this.M2_DATA_FOLDER || this.M1_DATA_FOLDER)) + filename, data)
}
	
	
MaxLib.objectToJSON = function(object){
	if(object == null || object == undefined){
		return 'null'
	}
	switch(object.constructor){
		case Boolean:
			return object.toString()
		case Number:
			return object.toString()
		case String:
			return '"' + escape(object) + '"'
		case Date:
			return Number(object).toString()
		case Array:
			var tempObj = []
			for(var i=0; i<object.length; i++){
				tempObj[i] = this.objectToJSON(object[i])
			}
			return '[' + tempObj.join(',') + ']'
		case Object:
			var tempObj = []
			for(var key in object){
				tempObj.push('"' + key + '" : ' + this.objectToJSON( object[key] ))
			}
			return '{\n   ' + tempObj.join(',\n   ') + '\n}\n'
		default:
			return 'null';
	}
}
	
/**********************   Settings   *****************************/

MaxLib.saveSettings = function(settingsObj){
	MaxLib.writeFile(this.SETTINGS_FILE, 'var settingsObj = ' + MaxLib.objectToJSON(settingsObj))
}


MaxLib.loadSettingsFile = function(){
	try{
		var settingsString = MaxLib.readFile(this.SETTINGS_FILE)
		if(settingsString && settingsString != ''){
			eval(settingsString)
		} else {
			throw new Error('Empty')
		}
		return settingsObj
	} catch(e){
		if(e.description != 'Empty'){
			alert('Loading Settings failed: ' + e.description + '\nThe Settings file will be overwritten.')
		}
		var defaultSettingsString = MaxLib.readFile(this.DEFAULT_SETTINGS_FILE, '/')
		eval(defaultSettingsString)
		MaxLib.writeFile(this.SETTINGS_FILE, defaultSettingsString)
		return settingsObj
	}
}


/**********************   for Maxthon 2.x   *****************************/
	
MaxLib.getM2DataPath = function(){
	try{
		var infoObj = external.max_getObj(SECURITY_ID, 'info')
		return infoObj.getFolderPluginData(PLUGIN_NAME)
	} catch(e) {
		return null
	}
}


MaxLib.M2_DATA_FOLDER = MaxLib.getM2DataPath()